import oscP5.*;

OscP5 oscP5;
int receiveAtPort;
int sendToPort;
String host;
String oscP5event;
int year = year();
int month = month();
int day = day();

void initOsc() {
  receiveAtPort = 10002;
  sendToPort = 10000;
  host = "localhost";
  oscP5event = "oscEvent";
  oscP5 = new OscP5(this, host, sendToPort, receiveAtPort, oscP5event);
}

void oscEvent(OscIn oscIn) {
  int mjd = int(oscIn.getFloat(0));
  writemjd(mjd);
}

void setup() {
  size(288, 288);
  background(0);
  PFont font;
//  font = loadFont("sansserif.plain-48.vlw");
//  textFont(font, 48);
  textSize(48);
  textAlign(CENTER);
  writecivil(year, month, day);
  initOsc();
}

void mousePressed() {
  OscMessage civil = new OscMessage("/getmjd/civil");
  civil.add(new Float(year));
  civil.add(new Float(month));
  civil.add(new Float(day));
  oscP5.send(civil);
}

void writecivil(int year, int month, int day) {
  String s = str(year) + "-";
  if (month < 10) {
    s += "0";
  }
  s += str(month) + "-";
  if (day < 10) {
    s += "0";
  }
  s += str(day);
  fill(192);
  text(s, width/2, height/3*1+48/3);
}

void writemjd(int mjd) {
  String s = "= " + str(mjd) + "MJD";
  fill(192);
  text(s, width/2, height/3*2+48/3);
}

void draw(){}
